############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

import time
from pyGridWare.notification.SubscriptionManager import SubscriptionManager
from pyGridWare.lifetime.ResourceLifetime import ImmediateResourceTermination
from pyGridWare.lifetime.ResourceLifetime import ScheduledResourceTermination
from PythonCLServiceTool.cat.underware.generated.resource.cat.PythonCLServiceTool_cat import ManagerHome
from PythonCLServiceTool.cat.underware.generated.resource.cat.PythonCLServiceTool_cat import PythonCLServiceTool_catPortTypeContext
from PythonCLServiceTool.cat.underware.generated.services.stubs.cat.PythonCLServiceTool_cat import *


class PythonCLServiceTool_catWSRF(PythonCLServiceTool_cat):

    def GetResourceContext(ps, address):
        """get a resource context"""
        return ManagerHome.getInstance().getResourceContext(ps, address)
    GetResourceContext = staticmethod(GetResourceContext)

    def NewResourceContextPythonCLServiceTool_catPort(cls, url):
        """create a new resource context"""
        ctx = PythonCLServiceTool_catPortTypeContext()
        ctx.setAddress(url)
        home = ctx.getResourceHome()
        key = home.create()
        home.add(ctx, key)
        ctx.setResourceID(key)
        return ctx
    NewResourceContextPythonCLServiceTool_catPort = classmethod(NewResourceContextPythonCLServiceTool_catPort)

    def wsa_create(self, ps, address, **kw):
        #urn:PythonCLServiceTool_cat createPythonCLServiceTool_catRequest
        response = PythonCLServiceTool_cat.wsa_create(self, ps, address)
        return response

    def wsa_run(self, ps, address, **kw):
        #urn:PythonCLServiceTool_cat RunRequestMessage
        response = PythonCLServiceTool_cat.wsa_run(self, ps, address)
        return response

    def wsa_GetResourceProperty(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl GetResourcePropertyRequest
        response = PythonCLServiceTool_cat.wsa_GetResourceProperty(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        namespaceURI,element = self.request
        property = ctx.properties.getResourceProperty(namespaceURI,element)
        response._any = [property]
        return response

    def wsa_Subscribe(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.wsdl SubscribeRequest
        response = PythonCLServiceTool_cat.wsa_Subscribe(self, ps, address)
        ctx = self.GetResourceContext(ps, address)
        assert SubscriptionManager._isInstantiated(),"SubscriptionManager is not instantiated"
        manager = SubscriptionManager.getInstance()
        response._SubscriptionReference = manager.subscribe(self.request, ctx)
        return response

    def wsa_GetCurrentMessage(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.wsdl GetCurrentMessageRequest
        response = PythonCLServiceTool_cat.wsa_GetCurrentMessage(self, ps, address)
        ctx = self.GetResourceContext(ps, address)
        assert SubscriptionManager._isInstantiated(),"SubscriptionManager is not instantiated"
        manager = SubscriptionManager.getInstance()
        response._any = manager.current(self.request, ctx)
        return response

    def wsa_Destroy(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl DestroyRequest
        response = PythonCLServiceTool_cat.wsa_Destroy(self, ps, address)
        ctx = PythonCLServiceTool_catWSRF.GetResourceContext(ps, address)
        ImmediateResourceTermination.Destroy(ctx)
        return response

    def wsa_SetTerminationTime(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl SetTerminationTimeRequest
        response = PythonCLServiceTool_cat.wsa_SetTerminationTime(self, ps, address)
        ctx = PythonCLServiceTool_catWSRF.GetResourceContext(ps, address)
        ScheduledResourceTermination.SetTerminationTime(ctx, self.request._RequestedTerminationTime)
        response._NewTerminationTime = time.gmtime(ctx.getTerminationTime())
        response._CurrentTime = time.gmtime(time.time())
        return response

